'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _flattenDepth2 = require('lodash/flattenDepth');

var _flattenDepth3 = _interopRequireDefault(_flattenDepth2);

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  line-height: ', ';\n  color: ', ';\n  min-height: ', ';\n\n  &:hover {\n    background-color: ', ';\n  }\n'], ['\n  line-height: ', ';\n  color: ', ';\n  min-height: ', ';\n\n  &:hover {\n    background-color: ', ';\n  }\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  border-radius: ', ';\n  background-color: ', ';\n  border: 1px solid ', ';\n  display: flex;\n\n  ', ' {\n    padding: 0;\n  }\n\n  div:last-child {\n    margin-left: auto;\n  }\n'], ['\n  border-radius: ', ';\n  background-color: ', ';\n  border: 1px solid ', ';\n  display: flex;\n\n  ', ' {\n    padding: 0;\n  }\n\n  div:last-child {\n    margin-left: auto;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var WIDTH = '256px';
var HEIGHT = '36px';

var Item = _styledComponents2.default.div.withConfig({
  displayName: 'Dropdown__Item'
})(['overflow:hidden;text-overflow:ellipsis;white-space:nowrap;padding:0 12px;cursor:pointer;']);

var Popover = _styledComponents2.default.div.withConfig({
  displayName: 'Dropdown__Popover'
})(['position:absolute;background-color:', ';border:1px solid ', ';border-radius:', ';z-index:', ';box-shadow:', ';margin-top:4px;width:', ';box-sizing:border-box;padding:6px 0;'], function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.theme.colors.silverDark;
}, function (props) {
  return props.theme.borderRadius.soft;
}, function (props) {
  return props.theme.layers.dropdown;
}, function (props) {
  return props.theme.boxShadow.light;
}, WIDTH);

var Overlay = _styledComponents2.default.div.withConfig({
  displayName: 'Dropdown__Overlay'
})(['z-index:', ';position:fixed;top:0;bottom:0;right:0;left:0;'], function (props) {
  return props.theme.layers.dropdown;
});

var ItemWrapper = Item.extend(_templateObject, HEIGHT, function (props) {
  return props.selected ? props.theme.colors.accent.blue : props.theme.textColor;
}, HEIGHT, function (props) {
  return props.theme.colors.gallery;
});

var Divider = _styledComponents2.default.div.withConfig({
  displayName: 'Dropdown__Divider'
})(['margin:6px 0;border-bottom:1px solid ', ';'], function (props) {
  return props.theme.colors.silverDark;
});

var SelectedItem = Item.extend(_templateObject2, function (props) {
  return props.theme.borderRadius.soft;
}, function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.theme.colors.dustyGray;
}, Item);

var SelectedItemIcon = _styledComponents2.default.span.withConfig({
  displayName: 'Dropdown__SelectedItemIcon'
})(['padding-left:1em;float:right;line-height:', ' !important;'], HEIGHT);

var StyledDropdown = function StyledDropdown(component) {
  return (0, _styledComponents2.default)(component).withConfig({
    displayName: 'Dropdown'
  })(['height:', ';line-height:', ';position:relative;padding:8px;width:', ';'], HEIGHT, HEIGHT, WIDTH);
};

/**
 * A selectable drop-down menu.
 * ```javascript
 *const items = [
 *  {
 *    value: 'first-thing',
 *    label: 'First Thing',
 *  },
 *  {
 *    value: 'second-thing',
 *    label: 'Second Thing',
 *  },
 * ];
 *
 * <Dropdown items={items} />
 * ```
 *
 * You  may also add `null` for dividers or provide groups that will be separated
 * ```javascript
 *const items = [
 *  [
 *    {
 *      value: 'first-thing',
 *      label: 'First Thing',
 *    },
 *    {
 *      value: 'second-thing',
 *      label: 'Second Thing',
 *    },
 *  ],
 *  [
 *    {
 *      value: 'another-thing',
 *      label: 'Another Thing',
 *    },
 *  ]
 * ];
 * ```
 */

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props, context) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props, context));

    _this.state = {
      isOpen: false
    };

    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    _this.handleBgClick = _this.handleBgClick.bind(_this);
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'handleChange',
    value: function handleChange(ev, value) {
      this.setState({ isOpen: false });
      if (this.props.onChange) {
        this.props.onChange(ev, value);
      }
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      this.setState({ isOpen: true });
    }
  }, {
    key: 'handleBgClick',
    value: function handleBgClick() {
      this.setState({ isOpen: false });
    }
  }, {
    key: 'divide',
    value: function divide(items) {
      if (!items || !(0, _isArray3.default)(items[0])) {
        return items;
      }

      return (0, _flattenDepth3.default)(items.map(function (it) {
        return [null, it];
      }), 2).slice(1);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          items = _props.items,
          value = _props.value,
          className = _props.className,
          placeholder = _props.placeholder;
      var isOpen = this.state.isOpen;

      var divided = this.divide(items);
      // If nothing is selected, use the placeholder, else use the first item.
      var currentItem = (0, _find3.default)(divided, function (i) {
        return i && i.value === value;
      }) || (placeholder ? { label: placeholder, value: null } : divided && divided[0]);

      return _react2.default.createElement(
        'div',
        { className: className, title: currentItem && currentItem.label },
        _react2.default.createElement(
          SelectedItem,
          { onClick: this.handleClick },
          _react2.default.createElement(
            Item,
            null,
            currentItem && currentItem.label
          ),
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(SelectedItemIcon, { className: 'fa fa-caret-down' })
          )
        ),
        isOpen && _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(Overlay, { onClick: this.handleBgClick }),
          _react2.default.createElement(
            Popover,
            null,
            (0, _map3.default)(divided, function (item, index) {
              return item ? _react2.default.createElement(
                ItemWrapper,
                {
                  className: 'dropdown-item',
                  key: item.value,
                  onClick: function onClick(ev) {
                    return _this2.handleChange(ev, item.value);
                  },
                  selected: item.value === value,
                  title: item && item.label
                },
                item.label
              ) : _react2.default.createElement(Divider, { key: index });
            })
          )
        )
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

var itemPropType = _propTypes2.default.shape({
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  label: _propTypes2.default.string
});

Dropdown.propTypes = {
  /**
   * Array of items (or groups of items) that will be selectable.
   * `value` should be an internal value,
   * `label` is what will be displayed to the user.
   */
  items: _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.arrayOf(itemPropType), itemPropType])).isRequired,
  /**
   * The value of the currently selected item. This much match a value in the `items` prop.
   * If no value is provided, the first elements's value will be used.
   */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  /**
   * A handler function that will run when a value is selected.
   */
  onChange: _propTypes2.default.func,
  /**
   * The initial text that will be display before a user selects an item.
   */
  placeholder: _propTypes2.default.string
};

exports.default = StyledDropdown(Dropdown);