'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  border-left: 3px solid ', ';\n  margin-left: -1px;\n  opacity: 0.2;\n'], ['\n  border-left: 3px solid ', ';\n  margin-left: -1px;\n  opacity: 0.2;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  border-left: 1px solid ', ';\n  opacity: 0.7;\n'], ['\n  border-left: 1px solid ', ';\n  opacity: 0.7;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Tooltip = require('./_Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _FocusPoint = require('./_FocusPoint');

var _FocusPoint2 = _interopRequireDefault(_FocusPoint);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var DeploymentInfoLine = _styledComponents2.default.span.withConfig({
  displayName: '_DeploymentAnnotations__DeploymentInfoLine'
})(['margin-top:1px;display:block;font-size:', ';white-space:nowrap;text-overflow:ellipsis;overflow:hidden;'], function (props) {
  return props.theme.fontSizes.small;
});

var DeploymentAnnotation = _styledComponents2.default.div.attrs({
  style: function style(_ref) {
    var left = _ref.left;
    return { left: left };
  }
}).withConfig({
  displayName: '_DeploymentAnnotations__DeploymentAnnotation'
})(['position:absolute;top:0;']);

var VerticalLine = _styledComponents2.default.div.attrs({
  style: function style(_ref2) {
    var height = _ref2.height;
    return { height: height };
  }
}).withConfig({
  displayName: '_DeploymentAnnotations__VerticalLine'
})(['pointer-events:none;position:absolute;top:0;']);

var DeploymentAnnotationShadow = VerticalLine.extend(_templateObject, function (props) {
  return props.theme.colors.white;
});

var DeploymentAnnotationLine = VerticalLine.extend(_templateObject2, function (props) {
  return props.theme.colors.accent.blue;
});

var formattedDeployments = function formattedDeployments(_ref3) {
  var deployments = _ref3.deployments,
      timeScale = _ref3.timeScale,
      chartWidth = _ref3.chartWidth;
  return deployments.map(function (_ref4) {
    var Data = _ref4.Data,
        Stamp = _ref4.Stamp;

    var _Data$split = Data.split(', '),
        _Data$split2 = _toArray(_Data$split),
        action = _Data$split2[0],
        serviceIDs = _Data$split2.slice(1);

    return {
      key: Data + ' --- ' + Stamp,
      position: timeScale((0, _moment2.default)(Stamp).unix()),
      timestamp: (0, _moment2.default)(Stamp).format(),
      serviceIDs: serviceIDs,
      action: action
    };
  }).filter(function (_ref5) {
    var position = _ref5.position;
    return (
      // Filter out all the deployments that fall out of the chart.
      chartWidth >= position && position >= 0
    );
  });
};

var DeploymentAnnotations = function (_React$PureComponent) {
  _inherits(DeploymentAnnotations, _React$PureComponent);

  function DeploymentAnnotations(props) {
    _classCallCheck(this, DeploymentAnnotations);

    var _this = _possibleConstructorReturn(this, (DeploymentAnnotations.__proto__ || Object.getPrototypeOf(DeploymentAnnotations)).call(this, props));

    _this.handleDeploymentMouseEnter = function (deployment) {
      _this.setState({ hoveredDeployment: deployment });
    };

    _this.handleDeploymentMouseLeave = function () {
      _this.setState({ hoveredDeployment: null });
    };

    _this.state = {
      hoveredDeployment: null,
      deployments: formattedDeployments(props)
    };
    return _this;
  }

  _createClass(DeploymentAnnotations, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ deployments: formattedDeployments(nextProps) });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var hoveredDeployment = this.state.hoveredDeployment;
      var _props = this.props,
          chartWidth = _props.chartWidth,
          chartHeight = _props.chartHeight,
          timeScale = _props.timeScale;

      var _timeScale$domain = timeScale.domain(),
          _timeScale$domain2 = _slicedToArray(_timeScale$domain, 2),
          startTimeSec = _timeScale$domain2[0],
          endTimeSec = _timeScale$domain2[1];

      if (!startTimeSec || !endTimeSec) return null;

      return _react2.default.createElement(
        'div',
        { className: 'deployment-annotations' },
        this.state.deployments.map(function (deployment) {
          return _react2.default.createElement(
            DeploymentAnnotation,
            { key: deployment.key, left: deployment.position },
            _react2.default.createElement(DeploymentAnnotationShadow, { height: chartHeight }),
            _react2.default.createElement(DeploymentAnnotationLine, { height: chartHeight }),
            _react2.default.createElement(_FocusPoint2.default, {
              hoverable: true,
              radius: '5',
              top: chartHeight,
              onMouseMove: function onMouseMove() {
                return _this2.handleDeploymentMouseEnter(deployment);
              },
              onMouseLeave: function onMouseLeave() {
                return _this2.handleDeploymentMouseLeave();
              }
            })
          );
        }),
        hoveredDeployment && _react2.default.createElement(
          _Tooltip2.default,
          {
            graphWidth: chartWidth,
            timestamp: hoveredDeployment.timestamp,
            x: hoveredDeployment.position,
            y: chartHeight
          },
          _react2.default.createElement(
            DeploymentInfoLine,
            null,
            _react2.default.createElement(
              'strong',
              null,
              hoveredDeployment.action
            )
          ),
          hoveredDeployment.serviceIDs.map(function (serviceId) {
            return _react2.default.createElement(
              DeploymentInfoLine,
              { key: serviceId },
              '\u2192 ',
              serviceId
            );
          })
        )
      );
    }
  }]);

  return DeploymentAnnotations;
}(_react2.default.PureComponent);

DeploymentAnnotations.propTypes = {
  chartWidth: _propTypes2.default.number.isRequired,
  chartHeight: _propTypes2.default.number.isRequired,
  timeScale: _propTypes2.default.func.isRequired,
  deployments: _propTypes2.default.array.isRequired
};

exports.default = DeploymentAnnotations;