'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _debounce2 = require('lodash/debounce');

var _debounce3 = _interopRequireDefault(_debounce2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  background-color: ', ';\n  box-shadow: inset 0 0 7px ', ';\n  pointer-events: all;\n'], ['\n  background-color: ', ';\n  box-shadow: inset 0 0 7px ', ';\n  pointer-events: all;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactResizeAware = require('react-resize-aware');

var _reactResizeAware2 = _interopRequireDefault(_reactResizeAware);

var _polished = require('polished');

var _d3Drag = require('d3-drag');

var _d3Selection = require('d3-selection');

var _reactMotion = require('react-motion');

var _animation = require('../../utils/animation');

var _timeline = require('../../utils/timeline');

var _zooming = require('../../utils/zooming');

var _TimelinePeriodLabels = require('./_TimelinePeriodLabels');

var _TimelinePeriodLabels2 = _interopRequireDefault(_TimelinePeriodLabels);

var _TimelineRange = require('./_TimelineRange');

var _TimelineRange2 = _interopRequireDefault(_TimelineRange);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var TIMELINE_HEIGHT = '55px';

var TimelineWrapper = _styledComponents2.default.div.withConfig({
  displayName: '_Timeline__TimelineWrapper'
})(['width:100%;height:', ';&:before,&:after{border:1px solid ', ';background-color:', ';box-sizing:border-box;content:\'\';pointer-events:none;position:absolute;display:block;left:50%;border-top:0;border-bottom:0;margin-left:-1px;width:3px;}&:before{top:0;height:', ';}&:after{top:', ';height:9px;opacity:0.15;}'], TIMELINE_HEIGHT, function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.theme.colors.accent.orange;
}, TIMELINE_HEIGHT, TIMELINE_HEIGHT);

// From https://stackoverflow.com/a/18294634
var FullyPannableCanvas = _styledComponents2.default.svg.withConfig({
  displayName: '_Timeline__FullyPannableCanvas'
})(['width:100%;height:100%;cursor:move;cursor:grab;cursor:-moz-grab;cursor:-webkit-grab;', ';'], function (props) {
  return props.panning && '\n    cursor: grabbing;\n    cursor: -moz-grabbing;\n    cursor: -webkit-grabbing;\n  ';
});

var TimelineContainer = FullyPannableCanvas.extend(_templateObject, function (props) {
  return (0, _polished.transparentize)(0.15, props.theme.colors.white);
}, function (props) {
  return props.theme.colors.gray;
});

var Timeline = function (_React$PureComponent) {
  _inherits(Timeline, _React$PureComponent);

  function Timeline(props) {
    _classCallCheck(this, Timeline);

    var _this = _possibleConstructorReturn(this, (Timeline.__proto__ || Object.getPrototypeOf(Timeline)).call(this, props));

    _this.state = {
      width: 0,
      height: 0,
      isPanning: false,
      hasPanned: false
    };

    _this.handleZoom = _this.handleZoom.bind(_this);
    _this.handlePanStart = _this.handlePanStart.bind(_this);
    _this.handlePanEnd = _this.handlePanEnd.bind(_this);
    _this.handlePan = _this.handlePan.bind(_this);
    _this.handleResize = (0, _debounce3.default)(_this.handleResize.bind(_this), 200);

    _this.saveSvgRef = _this.saveSvgRef.bind(_this);
    return _this;
  }

  _createClass(Timeline, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.svg = (0, _d3Selection.select)(this.svgRef);
      this.drag = (0, _d3Drag.drag)().on('start', this.handlePanStart).on('end', this.handlePanEnd).on('drag', this.handlePan);
      this.svg.call(this.drag);
    }
  }, {
    key: 'handlePanStart',
    value: function handlePanStart() {
      this.setState({ isPanning: true });
    }
  }, {
    key: 'handlePanEnd',
    value: function handlePanEnd() {
      if (this.state.hasPanned) {
        this.props.onRelease();
      }
      this.setState({ isPanning: false, hasPanned: false });
    }
  }, {
    key: 'handlePan',
    value: function handlePan() {
      var timeScale = (0, _timeline.getTimeScale)(this.props);
      var momentTimestamp = timeScale.invert(-_d3Selection.event.dx);
      this.props.onPan(momentTimestamp);
      this.setState({ hasPanned: true });
    }
  }, {
    key: 'handleZoom',
    value: function handleZoom(ev) {
      var durationMsPerPixel = this.props.durationMsPerPixel;

      this.props.onZoom(durationMsPerPixel / (0, _zooming.zoomFactor)(ev));
      ev.preventDefault();
    }
  }, {
    key: 'handleResize',
    value: function handleResize(_ref) {
      var width = _ref.width,
          height = _ref.height;

      // Update the timeline dimension information.
      this.setState({ width: width, height: height });
      this.props.onResize(width);
    }
  }, {
    key: 'saveSvgRef',
    value: function saveSvgRef(ref) {
      this.svgRef = ref;
    }
  }, {
    key: 'renderAxis',
    value: function renderAxis(transform) {
      var _this2 = this;

      var _state = this.state,
          width = _state.width,
          height = _state.height;
      var focusedTimestamp = transform.focusedTimestamp,
          rangeMs = transform.rangeMs;

      var startTimestamp = (0, _moment2.default)(focusedTimestamp).subtract(rangeMs).format();
      var timeScale = (0, _timeline.getTimeScale)(transform);

      return _react2.default.createElement(
        'g',
        { className: 'axis' },
        _react2.default.createElement('rect', {
          className: 'tooltip-container',
          transform: 'translate(' + -width / 2 + ', 0)',
          width: width,
          height: height,
          fillOpacity: 0
        }),
        _react2.default.createElement(_TimelineRange2.default, {
          color: '#aaa',
          width: width,
          height: height,
          endAt: this.props.earliestTimestamp,
          timeScale: timeScale
        }),
        _react2.default.createElement(_TimelineRange2.default, {
          color: '#aaa',
          width: width,
          height: height,
          startAt: this.props.timestampNow,
          timeScale: timeScale
        }),
        this.props.inspectingInterval && _react2.default.createElement(_TimelineRange2.default, {
          color: '#00d2ff',
          width: width,
          height: height,
          startAt: startTimestamp,
          endAt: focusedTimestamp,
          timeScale: timeScale
        }),
        _react2.default.createElement(
          'g',
          { className: 'ticks', transform: 'translate(0, 1)' },
          ['year', 'month', 'day', 'minute'].map(function (period) {
            return _react2.default.createElement(_TimelinePeriodLabels2.default, _extends({
              key: period,
              period: period,
              width: width,
              onClick: _this2.props.onJump,
              clickableStartAt: _this2.props.earliestTimestamp,
              clickableEndAt: _this2.props.timestampNow
            }, transform));
          })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state2 = this.state,
          isPanning = _state2.isPanning,
          width = _state2.width;
      var _props = this.props,
          focusedTimestamp = _props.focusedTimestamp,
          durationMsPerPixel = _props.durationMsPerPixel,
          rangeMs = _props.rangeMs;


      return _react2.default.createElement(
        TimelineWrapper,
        null,
        _react2.default.createElement(
          _reactResizeAware2.default,
          {
            onlyEvent: true,
            onResize: this.handleResize,
            style: { width: '100%', height: '100%' }
          },
          _react2.default.createElement(
            TimelineContainer,
            {
              panning: isPanning,
              innerRef: this.saveSvgRef,
              onWheel: this.handleZoom
            },
            _react2.default.createElement(
              'g',
              {
                className: 'timeline-container',
                transform: 'translate(' + width / 2 + ', 0)'
              },
              _react2.default.createElement(
                'title',
                null,
                'Scroll to zoom, drag to pan'
              ),
              _react2.default.createElement(
                _reactMotion.Motion,
                {
                  style: {
                    focusedTimestampMs: (0, _animation.strongSpring)((0, _moment2.default)(focusedTimestamp).valueOf()),
                    durationMsPerPixel: (0, _animation.strongSpring)(durationMsPerPixel),
                    rangeMs: (0, _animation.strongSpring)(rangeMs)
                  }
                },
                function (interpolated) {
                  return _this3.renderAxis({
                    focusedTimestamp: (0, _timeline.formattedTimestamp)(interpolated.focusedTimestampMs),
                    durationMsPerPixel: interpolated.durationMsPerPixel,
                    rangeMs: interpolated.rangeMs
                  });
                }
              )
            )
          )
        )
      );
    }
  }]);

  return Timeline;
}(_react2.default.PureComponent);

Timeline.propTypes = {
  inspectingInterval: _propTypes2.default.bool.isRequired,
  timestampNow: _propTypes2.default.string.isRequired,
  focusedTimestamp: _propTypes2.default.string.isRequired,
  earliestTimestamp: _propTypes2.default.string,
  durationMsPerPixel: _propTypes2.default.number.isRequired,
  rangeMs: _propTypes2.default.number.isRequired,
  onJump: _propTypes2.default.func.isRequired,
  onZoom: _propTypes2.default.func.isRequired,
  onPan: _propTypes2.default.func.isRequired,
  onRelease: _propTypes2.default.func.isRequired,
  onResize: _propTypes2.default.func.isRequired
};

exports.default = Timeline;