'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TimelineLabelContainer = _styledComponents2.default.button.withConfig({
  displayName: '_TimelineLabel__TimelineLabelContainer'
})(['background-color:transparent;color:', ';font-size:', ';cursor:pointer;margin-left:2px;padding:3px;outline:0;border:0;&::-moz-focus-inner{border:0;}&:focus{outline:none;}&[disabled]{color:', ';cursor:inherit;}&:not([disabled]):hover{color:', ';}'], function (props) {
  return props.theme.colors.primary.lavender;
}, function (props) {
  return props.theme.fontSizes.small;
}, function (props) {
  return props.theme.colors.gray;
}, function (props) {
  return props.theme.colors.primary.charcoal;
});

var TimelineLabel = function (_React$Component) {
  _inherits(TimelineLabel, _React$Component);

  function TimelineLabel(props) {
    _classCallCheck(this, TimelineLabel);

    var _this = _possibleConstructorReturn(this, (TimelineLabel.__proto__ || Object.getPrototypeOf(TimelineLabel)).call(this, props));

    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  _createClass(TimelineLabel, [{
    key: 'handleClick',
    value: function handleClick() {
      if (!this.props.disabled) {
        this.props.onClick(this.props.timestamp);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          periodFormat = _props.periodFormat,
          timestamp = _props.timestamp,
          position = _props.position,
          isBehind = _props.isBehind,
          disabled = _props.disabled;


      return _react2.default.createElement(
        'g',
        { transform: 'translate(' + position + ', 0)' },
        !isBehind && _react2.default.createElement('line', { y2: '75', stroke: '#ddd', strokeWidth: '1' }),
        !disabled && _react2.default.createElement(
          'title',
          null,
          'Jump to ',
          timestamp
        ),
        _react2.default.createElement(
          'foreignObject',
          { width: '100', height: '20', style: { lineHeight: '20px' } },
          _react2.default.createElement(
            TimelineLabelContainer,
            {
              onClick: this.handleClick,
              disabled: disabled
            },
            (0, _moment2.default)(timestamp).utc().format(periodFormat)
          )
        )
      );
    }
  }]);

  return TimelineLabel;
}(_react2.default.Component);

TimelineLabel.propTypes = {
  periodFormat: _propTypes2.default.string.isRequired,
  timestamp: _propTypes2.default.string.isRequired,
  position: _propTypes2.default.number.isRequired,
  onClick: _propTypes2.default.func.isRequired,
  disabled: _propTypes2.default.bool,
  isBehind: _propTypes2.default.bool
};

exports.default = TimelineLabel;